unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PCSCConnector, StdCtrls;

type
  TForm1 = class(TForm)
    PCSCConnector1: TPCSCConnector;
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure PCSCConnector1Error(Sender: TObject; ProcSource: TProcSource;
      ErrCode: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  THCardRecord = record
    CardNo: string;
    HolderName: string;
    IDN: string;
    BirthDate: TDateTime;
    Sex: string;
    IssueDate: TDateTime;
  end;

function GetHCardRecord(Data: string): THCardRecord;
begin
  Data := Hex2Bin(Data);
  Result.CardNo := Copy(Data, 1, 12);
  Result.HolderName := Copy(Data, 13, 6);
  Result.IDN := Copy(Data, 33, 10);
  Result.BirthDate := EncodeDate(StrToIntDef(Copy(Data, 44, 2), 1) + 1911, StrToIntDef(Copy(Data, 46, 2), 1), StrToIntDef(Copy(Data, 48, 2), 1));
  Result.Sex := Copy(Data, 50, 1);
  Result.IssueDate := EncodeDate(StrToIntDef(Copy(Data, 52, 2), 1) + 1911, StrToIntDef(Copy(Data, 54, 2), 1), StrToIntDef(Copy(Data, 56, 2), 1));
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  BoolStr: array [Boolean] of string = ('False', 'True');
begin
  PCSCConnector1.Refresh;
  
  Memo1.Lines.Clear;

  if PCSCConnector1.APIReady then
    Memo1.Lines.Add('API Ready.');

  Memo1.Lines.Add('Card Reader List:');
  Memo1.Lines.AddStrings(PCSCConnector1.ReaderList);

  if PCSCConnector1.ReaderList.Count > 0 then
  begin
    PCSCConnector1.ReaderIndex := 0;

    Memo1.Lines.Add('CardPresent: ' + BoolStr[PCSCConnector1.CardPresent]);
    Memo1.Lines.Add('CardMute: ' + BoolStr[PCSCConnector1.CardMute]);
    Memo1.Lines.Add('ReaderPadding: ' + BoolStr[PCSCConnector1.ReaderPadding]);

    PCSCConnector1.Connect;
    if PCSCConnector1.Connected then
    begin
      Memo1.Lines.Add('Card Reader Connected.');
      Memo1.Lines.Add('Select APDU: ' + PCSCConnector1.GetResponseFromCard('00 A4 04 00 10 D1 58 00 00 01 00 00 00 00 00 00 00 00 00 11 00'));

      with GetHCardRecord(PCSCConnector1.GetResponseFromCard('00 CA 11 00 02 00 00')) do
      begin
        Memo1.Lines.Add('Card NO: ' + CardNo);
        Memo1.Lines.Add('Name: ' + HolderName);
        Memo1.Lines.Add('IDN: ' + IDN);
        Memo1.Lines.Add('Birth Date: ' + FormatDateTime('YYYY/MM/DD', BirthDate));
        Memo1.Lines.Add('Sex: ' + Sex);
        Memo1.Lines.Add('Issue Date: ' + FormatDateTime('YYYY/MM/DD', IssueDate));
      end;

      PCSCConnector1.Disconnect;
    end
    else
      Memo1.Lines.Add('Card Reader Connect Fail.');
  end;
end;

procedure TForm1.PCSCConnector1Error(Sender: TObject;
  ProcSource: TProcSource; ErrCode: Integer);
begin
  Memo1.Lines.Add('Error: ' + IntToStr(ErrCode));
end;

end.
